; ModuleID = 'test_malloc.bc'
target datalayout = "e-p:32:32"
target triple = "rica-unknown-unknown"

%struct.freelist_entry = type { i32, %struct.freelist_entry* }

@__malloc_end = global i8* inttoptr (i64 10000 to i8*), align 4 ; <i8**> [#uses=3]
@__malloc_freelist = global %struct.freelist_entry* null, align 4 ; <%struct.freelist_entry**> [#uses=7]
@entries = global i32 3, align 4                  ; <i32*> [#uses=1]
@result = common global i32 0, align 4            ; <i32*> [#uses=1]

define i32 @main() nounwind {
entry:
  %tmp = load i32* @entries                       ; <i32> [#uses=4]
  %call = malloc i32, i32 %tmp                    ; <i32*> [#uses=3]
  %cmp42 = icmp sgt i32 %tmp, 0                   ; <i1> [#uses=2]
  br i1 %cmp42, label %for.body, label %for.end

for.body:                                         ; preds = %for.body, %entry
  %i.040 = phi i32 [ 0, %entry ], [ %add, %for.body ] ; <i32> [#uses=2]
  %arrayidx = getelementptr i32* %call, i32 %i.040 ; <i32*> [#uses=1]
  %add = add i32 %i.040, 1                        ; <i32> [#uses=3]
  store i32 %add, i32* %arrayidx
  %exitcond44 = icmp eq i32 %add, %tmp            ; <i1> [#uses=1]
  br i1 %exitcond44, label %for.end, label %for.body

for.end:                                          ; preds = %for.body, %entry
  %call9 = malloc i32                             ; <i32*> [#uses=3]
  store i32 0, i32* %call9, align 8
  br i1 %cmp42, label %for.body17, label %for.end28

for.cond12.for.end28_crit_edge:                   ; preds = %for.body17
  store i32 %add24, i32* %call9, align 8
  br label %for.end28

for.body17:                                       ; preds = %for.body17, %for.end
  %call9.tmp.0 = phi i32 [ 0, %for.end ], [ %add24, %for.body17 ] ; <i32> [#uses=1]
  %i.137 = phi i32 [ 0, %for.end ], [ %inc27, %for.body17 ] ; <i32> [#uses=2]
  %arrayidx20 = getelementptr i32* %call, i32 %i.137 ; <i32*> [#uses=1]
  %tmp21 = load i32* %arrayidx20                  ; <i32> [#uses=1]
  %add24 = add nsw i32 %call9.tmp.0, %tmp21       ; <i32> [#uses=3]
  %inc27 = add nsw i32 %i.137, 1                  ; <i32> [#uses=2]
  %exitcond = icmp eq i32 %inc27, %tmp            ; <i1> [#uses=1]
  br i1 %exitcond, label %for.cond12.for.end28_crit_edge, label %for.body17

for.end28:                                        ; preds = %for.cond12.for.end28_crit_edge, %for.end
  %tmp30 = phi i32 [ %add24, %for.cond12.for.end28_crit_edge ], [ 0, %for.end ] ; <i32> [#uses=1]
  store i32 %tmp30, i32* @result
  free i32* %call
  free i32* %call9
  ret i32 0
}

define i8* @malloc(i32 %sz) nounwind {
entry:
  %cmp = icmp ult i32 %sz, 4                      ; <i1> [#uses=1]
  br i1 %cmp, label %cond.end, label %cond.false

cond.false:                                       ; preds = %entry
  %neg = sub i32 0, %sz                           ; <i32> [#uses=1]
  %and = and i32 %neg, 3                          ; <i32> [#uses=1]
  %add = add i32 %sz, 4                           ; <i32> [#uses=1]
  %add3 = add i32 %add, %and                      ; <i32> [#uses=1]
  br label %cond.end

cond.end:                                         ; preds = %cond.false, %entry
  %cond = phi i32 [ %add3, %cond.false ], [ 8, %entry ] ; <i32> [#uses=9]
  %tmp53 = load i8** @__malloc_end                ; <i8*> [#uses=4]
  %tmp5.pre = load %struct.freelist_entry** @__malloc_freelist ; <%struct.freelist_entry*> [#uses=1]
  br label %for.cond

for.cond:                                         ; preds = %land.lhs.true, %if.end, %cond.end
  %tmp5 = phi %struct.freelist_entry* [ %tmp5.pre, %cond.end ], [ %tmp51, %land.lhs.true ], [ %tmp51, %if.end ] ; <%struct.freelist_entry*> [#uses=9]
  %nextfree.0 = phi %struct.freelist_entry** [ @__malloc_freelist, %cond.end ], [ %tmp50, %land.lhs.true ], [ %tmp50, %if.end ] ; <%struct.freelist_entry**> [#uses=4]
  %tobool = icmp eq %struct.freelist_entry* %tmp5, null ; <i1> [#uses=1]
  br i1 %tobool, label %for.end, label %for.body

for.body:                                         ; preds = %for.cond
  %tmp9 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 0 ; <i32*> [#uses=1]
  %tmp10 = load i32* %tmp9                        ; <i32> [#uses=5]
  %cmp12 = icmp ult i32 %tmp10, %cond             ; <i1> [#uses=1]
  br i1 %cmp12, label %if.end, label %if.then

if.then:                                          ; preds = %for.body
  %add17 = add i32 %cond, 8                       ; <i32> [#uses=1]
  %cmp18 = icmp ult i32 %tmp10, %add17            ; <i1> [#uses=1]
  br i1 %cmp18, label %if.then19, label %if.else

if.then19:                                        ; preds = %if.then
  %tmp21 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=2]
  %tmp22 = load %struct.freelist_entry** %tmp21   ; <%struct.freelist_entry*> [#uses=1]
  store %struct.freelist_entry* %tmp22, %struct.freelist_entry** %nextfree.0
  %conv = bitcast %struct.freelist_entry** %tmp21 to i8* ; <i8*> [#uses=1]
  ret i8* %conv

if.else:                                          ; preds = %if.then
  %sub = sub i32 %tmp10, %cond                    ; <i32> [#uses=1]
  %tmp33 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  %tmp34 = load %struct.freelist_entry** %tmp33   ; <%struct.freelist_entry*> [#uses=1]
  %conv36 = ptrtoint %struct.freelist_entry* %tmp5 to i32 ; <i32> [#uses=1]
  %add38 = add i32 %conv36, %cond                 ; <i32> [#uses=1]
  %conv39 = inttoptr i32 %add38 to %struct.freelist_entry* ; <%struct.freelist_entry*> [#uses=2]
  store %struct.freelist_entry* %conv39, %struct.freelist_entry** %nextfree.0
  %tmp44 = getelementptr inbounds %struct.freelist_entry* %conv39, i32 0, i32 0 ; <i32*> [#uses=1]
  store i32 %sub, i32* %tmp44
  %tmp47 = load %struct.freelist_entry** %nextfree.0 ; <%struct.freelist_entry*> [#uses=1]
  %tmp48 = getelementptr inbounds %struct.freelist_entry* %tmp47, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  store %struct.freelist_entry* %tmp34, %struct.freelist_entry** %tmp48
  br label %done

if.end:                                           ; preds = %for.body
  %tmp50 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=3]
  %tmp51 = load %struct.freelist_entry** %tmp50   ; <%struct.freelist_entry*> [#uses=3]
  %tobool52 = icmp eq %struct.freelist_entry* %tmp51, null ; <i1> [#uses=1]
  br i1 %tobool52, label %land.lhs.true, label %for.cond

land.lhs.true:                                    ; preds = %if.end
  %conv55 = ptrtoint %struct.freelist_entry* %tmp5 to i32 ; <i32> [#uses=2]
  %add59 = add i32 %tmp10, %conv55                ; <i32> [#uses=1]
  %conv60 = inttoptr i32 %add59 to i8*            ; <i8*> [#uses=1]
  %cmp61 = icmp eq i8* %tmp53, %conv60            ; <i1> [#uses=1]
  br i1 %cmp61, label %if.then63, label %for.cond

if.then63:                                        ; preds = %land.lhs.true
  %sub69 = sub i32 %cond, %tmp10                  ; <i32> [#uses=1]
  %0 = tail call i8* @llvm.frameaddress(i32 0)    ; <i8*> [#uses=1]
  %conv70 = ptrtoint i8* %0 to i32                ; <i32> [#uses=1]
  %conv72 = ptrtoint i8* %tmp53 to i32            ; <i32> [#uses=1]
  %sub73 = add i32 %conv70, -32                   ; <i32> [#uses=1]
  %sub74 = sub i32 %sub73, %conv72                ; <i32> [#uses=1]
  %cmp76 = icmp ult i32 %sub74, %sub69            ; <i1> [#uses=1]
  br i1 %cmp76, label %return, label %if.end79

if.end79:                                         ; preds = %if.then63
  store %struct.freelist_entry* null, %struct.freelist_entry** %nextfree.0
  %add84 = add i32 %conv55, %cond                 ; <i32> [#uses=1]
  %conv85 = inttoptr i32 %add84 to i8*            ; <i8*> [#uses=1]
  store i8* %conv85, i8** @__malloc_end
  br label %done

for.end:                                          ; preds = %for.cond
  %1 = tail call i8* @llvm.frameaddress(i32 0)    ; <i8*> [#uses=1]
  %conv90 = ptrtoint i8* %1 to i32                ; <i32> [#uses=1]
  %conv92 = ptrtoint i8* %tmp53 to i32            ; <i32> [#uses=2]
  %sub93 = add i32 %conv90, -32                   ; <i32> [#uses=1]
  %sub94 = sub i32 %sub93, %conv92                ; <i32> [#uses=1]
  %cmp96 = icmp ult i32 %sub94, %cond             ; <i1> [#uses=1]
  br i1 %cmp96, label %return, label %if.end99

if.end99:                                         ; preds = %for.end
  %conv101 = bitcast i8* %tmp53 to %struct.freelist_entry* ; <%struct.freelist_entry*> [#uses=1]
  %add105 = add i32 %conv92, %cond                ; <i32> [#uses=1]
  %conv106 = inttoptr i32 %add105 to i8*          ; <i8*> [#uses=1]
  store i8* %conv106, i8** @__malloc_end
  br label %done

done:                                             ; preds = %if.end99, %if.end79, %if.else
  %block.0 = phi %struct.freelist_entry* [ %tmp5, %if.else ], [ %tmp5, %if.end79 ], [ %conv101, %if.end99 ] ; <%struct.freelist_entry*> [#uses=2]
  %tmp109 = getelementptr inbounds %struct.freelist_entry* %block.0, i32 0, i32 0 ; <i32*> [#uses=1]
  store i32 %cond, i32* %tmp109
  %tmp111 = getelementptr inbounds %struct.freelist_entry* %block.0, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  %conv112 = bitcast %struct.freelist_entry** %tmp111 to i8* ; <i8*> [#uses=1]
  ret i8* %conv112

return:                                           ; preds = %for.end, %if.then63
  ret i8* null
}

declare i8* @llvm.frameaddress(i32) nounwind readnone

define void @free(i8* %block_p) nounwind {
entry:
  %conv = ptrtoint i8* %block_p to i32            ; <i32> [#uses=1]
  %sub = sub i32 %conv, ptrtoint (%struct.freelist_entry** getelementptr inbounds (%struct.freelist_entry* null, i32 0, i32 1) to i32) ; <i32> [#uses=4]
  %conv1 = inttoptr i32 %sub to %struct.freelist_entry* ; <%struct.freelist_entry*> [#uses=6]
  %cmp = icmp eq i8* %block_p, null               ; <i1> [#uses=1]
  br i1 %cmp, label %return, label %for.cond.preheader

for.cond.preheader:                               ; preds = %entry
  %tmp65 = getelementptr inbounds %struct.freelist_entry* %conv1, i32 0, i32 0 ; <i32*> [#uses=3]
  br label %for.cond

for.cond:                                         ; preds = %for.inc, %for.cond.preheader
  %nextfree.0 = phi %struct.freelist_entry** [ %tmp98, %for.inc ], [ @__malloc_freelist, %for.cond.preheader ] ; <%struct.freelist_entry**> [#uses=3]
  %tmp5 = load %struct.freelist_entry** %nextfree.0 ; <%struct.freelist_entry*> [#uses=8]
  %tobool = icmp eq %struct.freelist_entry* %tmp5, null ; <i1> [#uses=1]
  br i1 %tobool, label %for.end, label %for.body

for.body:                                         ; preds = %for.cond
  %conv10 = ptrtoint %struct.freelist_entry* %tmp5 to i32 ; <i32> [#uses=2]
  %tmp12 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 0 ; <i32*> [#uses=3]
  %tmp13 = load i32* %tmp12                       ; <i32> [#uses=3]
  %add = add i32 %conv10, %tmp13                  ; <i32> [#uses=1]
  %cmp16 = icmp eq i32 %add, %sub                 ; <i1> [#uses=1]
  %tmp21 = load i32* %tmp65                       ; <i32> [#uses=3]
  br i1 %cmp16, label %if.then18, label %if.else

if.then18:                                        ; preds = %for.body
  %add25 = add i32 %tmp13, %tmp21                 ; <i32> [#uses=2]
  store i32 %add25, i32* %tmp12
  %tmp27 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=2]
  %tmp28 = load %struct.freelist_entry** %tmp27   ; <%struct.freelist_entry*> [#uses=4]
  %tobool29 = icmp eq %struct.freelist_entry* %tmp28, null ; <i1> [#uses=1]
  br i1 %tobool29, label %return, label %land.lhs.true

land.lhs.true:                                    ; preds = %if.then18
  %tmp34 = load i32* %tmp65                       ; <i32> [#uses=1]
  %add35 = add i32 %tmp34, %sub                   ; <i32> [#uses=1]
  %conv39 = ptrtoint %struct.freelist_entry* %tmp28 to i32 ; <i32> [#uses=1]
  %cmp40 = icmp eq i32 %add35, %conv39            ; <i1> [#uses=1]
  br i1 %cmp40, label %if.then42, label %return

if.then42:                                        ; preds = %land.lhs.true
  %tmp46 = getelementptr inbounds %struct.freelist_entry* %tmp28, i32 0, i32 0 ; <i32*> [#uses=1]
  %tmp47 = load i32* %tmp46                       ; <i32> [#uses=1]
  %add51 = add i32 %add25, %tmp47                 ; <i32> [#uses=1]
  store i32 %add51, i32* %tmp12
  %tmp55 = getelementptr inbounds %struct.freelist_entry* %tmp28, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  %tmp56 = load %struct.freelist_entry** %tmp55   ; <%struct.freelist_entry*> [#uses=1]
  store %struct.freelist_entry* %tmp56, %struct.freelist_entry** %tmp27
  ret void

if.else:                                          ; preds = %for.body
  %add67 = add i32 %tmp21, %sub                   ; <i32> [#uses=1]
  %cmp68 = icmp eq i32 %conv10, %add67            ; <i1> [#uses=1]
  br i1 %cmp68, label %if.then70, label %if.else85

if.then70:                                        ; preds = %if.else
  %add77 = add i32 %tmp21, %tmp13                 ; <i32> [#uses=1]
  store i32 %add77, i32* %tmp65
  %tmp79 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  %tmp80 = load %struct.freelist_entry** %tmp79   ; <%struct.freelist_entry*> [#uses=1]
  %tmp82 = getelementptr inbounds %struct.freelist_entry* %conv1, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  store %struct.freelist_entry* %tmp80, %struct.freelist_entry** %tmp82
  store %struct.freelist_entry* %conv1, %struct.freelist_entry** %nextfree.0
  ret void

if.else85:                                        ; preds = %if.else
  %cmp90 = icmp ugt %struct.freelist_entry* %tmp5, %conv1 ; <i1> [#uses=1]
  br i1 %cmp90, label %for.end, label %for.inc

for.inc:                                          ; preds = %if.else85
  %tmp98 = getelementptr inbounds %struct.freelist_entry* %tmp5, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  br label %for.cond

for.end:                                          ; preds = %if.else85, %for.cond
  %tmp102 = getelementptr inbounds %struct.freelist_entry* %conv1, i32 0, i32 1 ; <%struct.freelist_entry**> [#uses=1]
  store %struct.freelist_entry* %tmp5, %struct.freelist_entry** %tmp102
  store %struct.freelist_entry* %conv1, %struct.freelist_entry** %nextfree.0
  ret void

return:                                           ; preds = %land.lhs.true, %if.then18, %entry
  ret void
}
